Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 21)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 21)
@@ -0,0 +1,456 @@
+package geniusweb.protocol.session.amop;
+
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.stream.Collectors;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
+import geniusweb.inform.Agreements;
+import geniusweb.inform.YourTurn;
+import geniusweb.issuevalue.Bid;
+import geniusweb.progress.Progress;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.protocol.session.SessionState;
+import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.voting.CollectedVotes;
+
+public class AMOPState implements SessionState {
+	/**
+	 * Phase determines what actions are allowed now. #isFinal terminates the
+	 * state.
+	 */
+	public enum Phase {
+		INIT, OFFER, VOTE;
+
+		public Phase next() {
+			return this == OFFER ? VOTE : OFFER;
+		}
+	}
+
+	private final Phase phase;
+	private final AMOPSettings settings;
+	private final Map<PartyId, PartyWithProfile> partyprofiles;
+	private final ProtocolToPartyConnections connections;
+	private final Agreements agreements;
+	private final List<PartyId> walkedAway;
+	private final List<Action> actions;
+	private final Progress progress;
+	private final Map<PartyId, ProtocolException> exceptions;
+
+	/**
+	 * Creates the initial state from the given settings and progress=null
+	 * 
+	 * @param settings the {@link SAOPSettings}
+	 */
+	public AMOPState(AMOPSettings settings) {
+		this(Phase.INIT, Collections.emptyList(),
+				new ProtocolToPartyConnections(Collections.emptyList()), null,
+				settings, Collections.emptyMap(), new Agreements(),
+				Collections.emptyMap(), Collections.emptyList());
+
+	}
+
+	/**
+	 * @param phase         The Phase
+	 * @param actions       the legal actions that have been done in the
+	 *                      negotiation. first action is the oldest. This MUST
+	 *                      NOT contain illegal actions, otherwise we can not
+	 *                      decypher the actions list anymore and find the
+	 *                      proper phase boundaries. Instead parties doing
+	 *                      illegal actions must be killed.
+	 * @param conns         the existing party connections. we assume ownership
+	 *                      of this so it should not be modified although
+	 *                      connections may of course break.
+	 * @param progress      the {@link Progress} line. can be null if not yet
+	 *                      known
+	 * @param settings      the {@link SAOPSettings}
+	 * @param partyprofiles map with the {@link PartyWithProfile} for connected
+	 *                      parties. null is equivalent to an empty map.
+	 * @param agreements    the agreements reached.
+	 * @param e             Possibly empty map of {@link ProtocolException}, the
+	 *                      keys are the party that failed to follow the
+	 *                      protocol.
+	 * @param walkedAway    list of parties that walked away from the
+	 *                      negotiation.
+	 */
+	protected AMOPState(Phase phase, List<Action> actions,
+			ProtocolToPartyConnections conns, Progress progress,
+			AMOPSettings settings, Map<PartyId, PartyWithProfile> partyprofiles,
+			Agreements agreements, Map<PartyId, ProtocolException> e,
+			List<PartyId> walkedAway) {
+		this.phase = phase;
+		this.actions = actions;
+		this.connections = conns;
+		this.progress = progress;
+		this.settings = settings;
+		this.partyprofiles = partyprofiles;
+		this.agreements = agreements;
+		this.exceptions = e;
+		this.walkedAway = walkedAway;
+	}
+
+	@Override
+	public List<Action> getActions() {
+		return Collections.unmodifiableList(actions);
+	}
+
+	@Override
+	public Progress getProgress() {
+		return progress;
+	}
+
+	public Map<PartyId, PartyWithProfile> getPartyProfiles() {
+		return Collections.unmodifiableMap(partyprofiles);
+	}
+
+	/**
+	 * @return all current/remaining active party connections. Finished/crashed
+	 *         parties should be removed immediately.
+	 */
+	public ProtocolToPartyConnections getConnections() {
+		return connections;
+	}
+
+	/**
+	 * 
+	 * @param connection   the new {@link ProtocolToPartyConn}
+	 * @param partyprofile the {@link PartyWithProfile} that is associated with
+	 *                     this state
+	 * @return new SessionState with the new connection added. This call ignores
+	 *         the progress (does not check isFinal) because we uses this during
+	 *         the setup where the deadline is not yet relevant.
+	 */
+	protected AMOPState with(ProtocolToPartyConn connection,
+			PartyWithProfile partyprofile) {
+		ProtocolToPartyConnections newconns = getConnections().with(connection);
+		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
+				partyprofiles);
+		newprofiles.put(connection.getParty(), partyprofile);
+		return new AMOPState(Phase.INIT, actions, newconns, progress, settings,
+				newprofiles, agreements, exceptions, walkedAway);
+	}
+
+	/**
+	 * @param id the {@link PartyId} of the party that failed.
+	 * @param e  the {@link ProtocolException} that occured in the party
+	 * @return a new state with the error set.
+	 */
+	public AMOPState with(PartyId id, ProtocolException e) {
+		Map<PartyId, ProtocolException> newExc = exceptions;
+		if (!exceptions.containsKey(id)) {
+			newExc = new HashMap<>(exceptions);
+			newExc.put(id, e);
+		}
+		return new AMOPState(phase, actions, connections, progress, settings,
+				partyprofiles, agreements, newExc, walkedAway);
+	}
+
+	/**
+	 * Sets the progress for this session. Can be set only if progress=null.
+	 * Should be set in INIT phase.
+	 * 
+	 * @param newprogress the new progress
+	 * @return new SAOPState with the progress set
+	 */
+	public AMOPState with(Progress newprogress) {
+		if (progress != null || newprogress == null || phase != Phase.INIT) {
+			throw new IllegalArgumentException(
+					"progress must be null, newprogress must be not null and phase must be INIT");
+		}
+		return new AMOPState(phase, actions, connections, newprogress,
+				getSettings(), partyprofiles, agreements, exceptions,
+				walkedAway);
+	}
+
+	@Override
+	public Agreements getAgreements() {
+		return agreements;
+	}
+
+	@Override
+	public boolean isFinal(long currentTimeMs) {
+		boolean pastDeadline = progress != null
+				&& progress.isPastDeadline(currentTimeMs);
+		return phase != Phase.INIT
+				&& (pastDeadline || getActiveParties().size() < 2);
+	}
+
+	@Override
+	public AMOPSettings getSettings() {
+		return settings;
+	}
+
+	/**
+	 * @param actor         the actor that did this action. Can be used to check
+	 *                      if action is valid. NOTICE caller has to make sure
+	 *                      the current state is not final. MUST NOT be null.
+	 * @param action        the action that was proposed by actor. MUST NOT be
+	 *                      null.
+	 * @param currentTimeMs the current time in ms since 1970, see
+	 *                      {@link System#currentTimeMillis()}
+	 * @return new SessionState with the action added as last action.
+	 * @throws ProtocolException if actor is violating the protocol
+	 * @throws RuntimeException  if we hit a bug.
+	 */
+
+	public AMOPState with(PartyId actor, Action action)
+			throws ProtocolException {
+		if (!actor.equals(action.getActor())) {
+			throw new ProtocolException(
+					"act by " + actor + " contains wrong actorid: " + action,
+					actor);
+		}
+		if (!getActiveParties().contains(actor))
+			throw new ProtocolException("Deactivated actor tried to act",
+					actor);
+		if (getPhaseActions().containsKey(actor))
+			throw new ProtocolException(
+					"Attempt to act twice in phase:" + action, actor);
+
+		List<Action> newactions = new LinkedList<>(getActions());
+		newactions.add(action);
+		List<PartyId> newWalkedAway = walkedAway;
+
+		// check protocol is followed for specific actions
+		if (action instanceof Votes) {
+			if (phase != Phase.VOTE)
+				throw new ProtocolException(
+						"Vote can only be placed in VOTE phase", actor);
+			// Notice we don't check the votes. You can actually vote for
+			// other bids. But such action would be useless as others can't vote
+			// on it.
+		} else if (action instanceof Offer) {
+			if (phase != Phase.OFFER) {
+				throw new ProtocolException(
+						"Offer can only be placed in OFFER phase", actor);
+			}
+		} else if (action instanceof EndNegotiation) {
+			newWalkedAway = new LinkedList<>(walkedAway);
+			newWalkedAway.add(action.getActor());
+
+		} else {
+			throw new ProtocolException(
+					"Action " + action + " is not allowed in AMOP", actor);
+		}
+
+		return new AMOPState(phase, newactions, connections, progress, settings,
+				partyprofiles, agreements, exceptions, newWalkedAway);
+	}
+
+	@Override
+	public SessionResult getResult() {
+		List<Double> emptylist = new LinkedList<>();
+		for (int n = 0; n < getConnections().size(); n++)
+			emptylist.add(0d);
+		return new SessionResult(getSettings().getAllParties(), getAgreements(),
+				emptylist, null);
+	}
+
+	/**
+	 * @return true iff all parties acted as required in the current Phase. We
+	 *         search back until the last {@link YourTurn} if Phase=VOTE. /
+	 *         {@link Vote} if Phase=OFFER and check that all current
+	 *         connections have acted.
+	 */
+	public boolean isAllPartiesActed() {
+		return getPhaseActions().keySet().containsAll(getActiveParties());
+	}
+
+	/**
+	 * @return all actions of the current phase NOTE this assumes at least 1
+	 *         action is done in each phase, so that we can detect the previous
+	 *         phase actions in the actions list.
+	 * 
+	 */
+	public Map<PartyId, Action> getPhaseActions() {
+		Map<PartyId, Action> newactions = new HashMap<>();
+		for (int n = actions.size() - 1; n >= 0; n--) {
+			Action act = actions.get(n);
+			if (act instanceof EndNegotiation)
+				continue;
+			if (phase == Phase.VOTE && !(act instanceof Votes))
+				break;
+			if (phase == Phase.OFFER && !(act instanceof Offer))
+				break;
+			newactions.put(act.getActor(), act);
+		}
+		return newactions;
+
+	}
+
+	/**
+	 * 
+	 * @return all currently active parties. These are the parties that do not
+	 *         yet have an {@link #agreements} nor caused {@link #exceptions}
+	 *         nor {@link #walkedAway}
+	 */
+	public List<PartyId> getActiveParties() {
+		List<PartyId> active = connections.stream().map(conn -> conn.getParty())
+				.collect(Collectors.toList());
+		active.removeAll(agreements.getMap().keySet());
+		active.removeAll(exceptions.keySet());
+		active.removeAll(walkedAway);
+		return active;
+	}
+
+	public Phase getPhase() {
+		return phase;
+	}
+
+	/**
+	 * 
+	 * @return list of parties that walked away with {@link EndNegotiation}
+	 */
+	public List<PartyId> getWalkedAway() {
+		return walkedAway;
+	}
+
+	/**
+	 * 
+	 * @return new state with next phase selected and a updated list of
+	 *         agreements. This must be called to end a phase, it's not
+	 *         triggered by an action. If current phase is VOTE and next phase
+	 *         OFFER then progress is also incremented.
+	 */
+	@SuppressWarnings({ "unchecked", "rawtypes" })
+	public AMOPState nextPhase() {
+		Agreements newagreements = agreements;
+		Progress newprogress = progress;
+		if (phase == Phase.VOTE) {
+			// hacky cast
+			newagreements = collectVotes((Map) getPhaseActions());
+			if (newprogress instanceof ProgressRounds) {
+				newprogress = ((ProgressRounds) newprogress).advance();
+			}
+		}
+		return new AMOPState(phase.next(), actions, connections, newprogress,
+				settings, partyprofiles, newagreements, exceptions, walkedAway);
+	}
+
+	/**
+	 * 
+	 * @param allvotes the Votes of each party
+	 * @return all agreements that were reached from the given votes
+	 */
+	protected Agreements collectVotes(Map<PartyId, Votes> allvotes) {
+		Agreements newagreements = agreements;
+		while (true) {
+			// power is 1 for each known party.
+			Map<PartyId, Integer> powers = allvotes.keySet().stream()
+					.collect(Collectors.toMap(p -> p, p -> 1));
+			Map<Bid, Set<PartyId>> agrees = new CollectedVotes(allvotes, powers)
+					.getMaxAgreements();
+			if (agrees.isEmpty())
+				break;
+			// find the best one
+			Bid maxbid = agrees.keySet().stream()
+					.max(Comparator.comparingInt(bid -> agrees.get(bid).size()))
+					.get();
+			newagreements = newagreements.with(maxbid, agrees.get(maxbid));
+			for (PartyId party : agrees.get(maxbid)) {
+				allvotes.remove(party);
+			}
+		}
+		return newagreements;
+	}
+
+	@Override
+	public String toString() {
+		return "AMOPState[" + phase + "," + settings + "," + partyprofiles + ","
+				+ connections + "," + agreements + "," + walkedAway + ","
+				+ actions + "," + progress + "," + exceptions + "," + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((actions == null) ? 0 : actions.hashCode());
+		result = prime * result
+				+ ((agreements == null) ? 0 : agreements.hashCode());
+		result = prime * result
+				+ ((connections == null) ? 0 : connections.hashCode());
+		result = prime * result
+				+ ((exceptions == null) ? 0 : exceptions.hashCode());
+		result = prime * result
+				+ ((partyprofiles == null) ? 0 : partyprofiles.hashCode());
+		result = prime * result + ((phase == null) ? 0 : phase.hashCode());
+		result = prime * result
+				+ ((progress == null) ? 0 : progress.hashCode());
+		result = prime * result
+				+ ((settings == null) ? 0 : settings.hashCode());
+		result = prime * result
+				+ ((walkedAway == null) ? 0 : walkedAway.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		AMOPState other = (AMOPState) obj;
+		if (actions == null) {
+			if (other.actions != null)
+				return false;
+		} else if (!actions.equals(other.actions))
+			return false;
+		if (agreements == null) {
+			if (other.agreements != null)
+				return false;
+		} else if (!agreements.equals(other.agreements))
+			return false;
+		if (connections == null) {
+			if (other.connections != null)
+				return false;
+		} else if (!connections.equals(other.connections))
+			return false;
+		if (exceptions == null) {
+			if (other.exceptions != null)
+				return false;
+		} else if (!exceptions.equals(other.exceptions))
+			return false;
+		if (partyprofiles == null) {
+			if (other.partyprofiles != null)
+				return false;
+		} else if (!partyprofiles.equals(other.partyprofiles))
+			return false;
+		if (phase != other.phase)
+			return false;
+		if (progress == null) {
+			if (other.progress != null)
+				return false;
+		} else if (!progress.equals(other.progress))
+			return false;
+		if (settings == null) {
+			if (other.settings != null)
+				return false;
+		} else if (!settings.equals(other.settings))
+			return false;
+		if (walkedAway == null) {
+			if (other.walkedAway != null)
+				return false;
+		} else if (!walkedAway.equals(other.walkedAway))
+			return false;
+		return true;
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 21)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 21)
@@ -0,0 +1,424 @@
+package geniusweb.protocol.session.mopac;
+
+import java.io.IOException;
+import java.util.List;
+import java.util.Timer;
+import java.util.TimerTask;
+import java.util.logging.Level;
+import java.util.stream.Collectors;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Votes;
+import geniusweb.deadline.Deadline;
+import geniusweb.events.ProtocolEvent;
+import geniusweb.inform.Agreements;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.Voting;
+import geniusweb.inform.YourTurn;
+import geniusweb.issuevalue.Bid;
+import geniusweb.progress.ProgressFactory;
+import geniusweb.protocol.CurrentNegoState;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.mopac.phase.Phase;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.logging.Reporter;
+import tudelft.utilities.repository.NoResourcesNowException;
+
+/**
+ * 
+ * All parties are first sent the {@link SessionSettings}. Only parties
+ * specified initially in the settings do participate (no late joining in)
+ * 
+ * <h1>parameter</h1> MOPAC parties can receive a parameter <code>power</code>
+ * containing a Integer. This parameter is picked up by this protocol, for
+ * handling the agreement extraction from the offers. Power=1 for parties that
+ * do not have the power parameter.
+ * <h1>Protocol steps</h1>
+ * 
+ * <ol>
+ * <li>The protocol tries to start all parties. If not all parties start, the
+ * parties are freed up and another attempt is done to start all parties some
+ * time later.
+ * <li>the variable remainingparties = {all parties}
+ * <li>The session deadline clock now starts ticking.
+ * <li>remainingparties are sent their settings.
+ * <li>Loop until {@link Deadline} is reached or |remainingparties|<2:
+ * <ol>
+ * <li>protocol sends {@link YourTurn} to all remainingparties. Each party now
+ * must submit an {@link Offer} within {@link Phase#PHASE_MAXTIME} seconds. If a
+ * party fails to submit it is removed from from remainingparties.
+ * <li>protocol sends a {@link Voting} containing a List<Bid> containing all
+ * received {@link Bid}s. Each party must place his {@link Votes} within
+ * {@link #PHASE_TIME} seconds. If a party does not submit, it is terminated and
+ * removed from remainingparties. Previous votes for the same bid do not count.
+ * But see {@link Agreements}. A party that misbehaves after submitting its vote
+ * is removed but it Votes remain standing.
+ * <li>protocol sends to all remainingparties a OptIn containing all received
+ * votes. Each party now must submit again a {@link Votes} object within
+ * {@link #PHASE_TIME} seconds. This new Votes must equal or extend the previous
+ * Votes of the party.
+ * <li>The protocol use the {@link MOPACState#getEvaluator()} to determine the
+ * ... . If there is such a subset, the parties that placed these votes reached
+ * an agreement. They are added to the agreement set, sent the {@link Finished}
+ * info and terminated. They are removed from the remainingparties.
+ * </ol>
+ * <li>Any remaining parties are sent a {@link Finished} object without
+ * agreement bid and are terminated.
+ * </ol>
+ * <p>
+ * A party can send {@link EndNegotiation} at any time to remove itself from the
+ * negotiation. The other parties may continue anyawy without him.
+ * <p>
+ * Parties receive the {@link Finished} information at the very end when all
+ * agreements have been collected.
+ * <p>
+ * This logs to "Protocol" logger if there are issues
+ * <p>
+ * This object is mutable: the internal state changes as parties interact with
+ * the protocol.
+ * <p>
+ * Threadsafe: all entrypoints are synhronized.
+ */
+public class MOPAC extends DefaultListenable<ProtocolEvent>
+		implements SessionProtocol {
+	/**
+	 * Tech notes. 0. Everything here is phase driven and runs due to callback
+	 * from parties. 1. Connect all parties. 2. If any party fails at any time,
+	 * add it to exceptions list in the state 3. Run timer to check the phase at
+	 * possible end time. The timer just checks the state, and therefore it does
+	 * no harm if it is double checked. 4. We run phases always with either
+	 * PHASE_TIME or time to the global deadline, whichever comes first.
+	 * Therefore phases naturally end at end of nego. 5. Phases must have at
+	 * least {@link #MINDURATION} otherwise it makes no sense to even start it.
+	 */
+	private static final int MINDURATION = 100;
+	private static final int MIN_SLEEP_TIME = 1000;
+	private static final int MAX_SLEEP_TIME = 60000;
+	private static final ProtocolRef MOPAC = new ProtocolRef("MOPAC");
+
+	private final Reporter log;
+	private MOPACState state = null; // mutable!
+
+	/**
+	 * Set to true after all is done: we sent final outcomes. This is needed
+	 * because we can't tell from state what we did at the very end.
+	 */
+	private boolean finished = false;
+	private Timer timer = null;
+
+	/**
+	 * 
+	 * @param state normally the initial state coming from SAOPSettings
+	 */
+	public MOPAC(MOPACState state, Reporter logger) {
+		if (state == null) {
+			throw new NullPointerException("state must be not null");
+		}
+		if (state.getSettings().getDeadline().getDuration() < MINDURATION) {
+			throw new IllegalArgumentException(
+					"Duration must be at least " + MINDURATION);
+		}
+		if (logger == null) {
+			throw new NullPointerException("Logger must be not null");
+		}
+		this.log = logger;
+		this.state = state;
+	}
+
+	@Override
+	public synchronized void start(
+			ProtocolToPartyConnFactory connectionfactory) {
+		try {
+			System.out.println("starting MOPAC");
+			// we're in Phase.INIT still
+			connect(connectionfactory);
+			setupParties();
+			long now = System.currentTimeMillis();
+			state = state.initPhase(now);
+			startPhase(now);
+		} catch (Throwable e) {
+			e.printStackTrace();
+			handleError("Failed to start MOPAC session", new PartyId("BUG"), e);
+		}
+	}
+
+	@Override
+	public String getDescription() {
+		return "All parties get YourTurn. They now can submit their Offer within 30 seconds. "
+				+ "Next they receive a Voting. They can now submit their Votes."
+				+ "Then they receive a a OptIn, now they can widen up their Votes."
+				+ "If one of their Vote succeeds, they finish with an agreement. "
+				+ "The VotingEvaluator setting determines the exact voting behaviour "
+				+ "and if this process repeats";
+	}
+
+	@Override
+	public void addParticipant(PartyWithProfile party)
+			throws IllegalStateException {
+		throw new IllegalStateException(
+				"Dynamic joining a negotiation is not supported in AMOP");
+	}
+
+	@Override
+	public MOPACState getState() {
+		return state;
+	}
+
+	@Override
+	public ProtocolRef getRef() {
+		return MOPAC;
+	}
+
+	/*******************************************************************
+	 * private functions. Some are protected only, for testing purposes
+	 ********************************************************************/
+	/**
+	 * step 1 in protocol: connect all involved parties and start the clock.
+	 * This always "succeeds" with a valid (but possibly final) state
+	 * <p>
+	 * This is 'protected' to allow junit testing, this code is not a 'public'
+	 * part of the interface.
+	 * 
+	 * @param connectionfactory the connectionfactory for making party
+	 *                          connections
+	 * 
+	 * @throws InterruptedException if the connection procedure is unterrupted
+	 * 
+	 * @throws IOException          if this fails to properly conect to the
+	 *                              parties, eg interrupted or server not
+	 *                              responding..
+	 */
+	protected synchronized void connect(
+			ProtocolToPartyConnFactory connectionfactory)
+			throws InterruptedException, IOException {
+		List<PartyWithProfile> participants = state.getSettings()
+				.getAllParties();
+		List<Reference> parties = participants.stream()
+				.map(parti -> (parti.getParty().getPartyRef()))
+				.collect(Collectors.toList());
+		List<ProtocolToPartyConn> connections = null;
+		log.log(Level.INFO, "MOPAC connect " + parties);
+		while (connections == null) {
+			try {
+				connections = connectionfactory.connect(parties);
+			} catch (NoResourcesNowException e) {
+				long waitms = e.getLater().getTime()
+						- System.currentTimeMillis();
+				log.log(Level.INFO,
+						"No resources available to run session, waiting"
+								+ waitms);
+				Thread.sleep(Math.min(MAX_SLEEP_TIME,
+						Math.max(MIN_SLEEP_TIME, waitms)));
+			}
+		}
+		for (int i = 0; i < participants.size(); i++) {
+			state = state.with(connections.get(i), participants.get(i));
+		}
+	}
+
+	/**
+	 * step 2 in protocol: listen to connections and send settings to the
+	 * parties.
+	 * <p>
+	 * This is 'protected' to allow junit testing, this code is not a 'public'
+	 * part of the interface.
+	 * 
+	 * @throws ProtocolException if a party does not follow the protocol
+	 */
+	protected synchronized void setupParties() throws ProtocolException {
+		for (ProtocolToPartyConn conn : state.getConnections()) {
+			conn.addListener(action -> actionRequest(conn, action,
+					System.currentTimeMillis()));
+		}
+		Long now = System.currentTimeMillis();
+		state = state.with(
+				ProgressFactory.create(state.getSettings().getDeadline(), now));
+		for (ProtocolToPartyConn connection : state.getConnections()) {
+			try {
+				sendSettings(connection);
+			} catch (IOException e) {
+				state = state.with(new ProtocolException("Failed to initialize",
+						connection.getParty()));
+			}
+		}
+
+	}
+
+	/**
+	 * Send the {@link Inform} for the curreent phase to all parties and start
+	 * the time-out checker
+	 */
+	private void startPhase(long now) {
+		broadcastNegotiators(state.getPhase().getInform());
+		startTimer(1 + state.getPhase().getDeadline() - now);
+	}
+
+	/**
+	 * Check at given deadline if we already ended the phase.
+	 * 
+	 * @param deadn the deadline
+	 */
+	private void startTimer(long deadln) {
+		if (timer != null)
+			throw new IllegalStateException("Timer is still running!");
+		timer = new Timer("deadlinetimer");
+		timer.schedule(new TimerTask() {
+			@Override
+			public void run() {
+				checkEndPhase(System.currentTimeMillis());
+			}
+		}, deadln);
+
+	}
+
+	/**
+	 * Inform a party about its settings
+	 * 
+	 * @param connection
+	 * @throws IOException if party got disconnected
+	 */
+	private synchronized void sendSettings(ProtocolToPartyConn connection)
+			throws IOException {
+		PartyId partyid = connection.getParty();
+		ProfileRef profile = state.getPartyProfiles().get(partyid).getProfile();
+		Parameters params = state.getPartyProfiles().get(partyid).getParty()
+				.getParameters();
+		connection.send(new Settings(connection.getParty(), profile, getRef(),
+				state.getProgress(), params));
+	}
+
+	/**
+	 * This is called when one of the {@link ProtocolToPartyConn}s does an
+	 * action. Synchronized so that we always handle only 1 action at a time.
+	 * 
+	 * @param partyconn the connection on which the action came in
+	 * @param action    the {@link Action} taken by some party
+	 * @param now       current time
+	 */
+	protected synchronized void actionRequest(
+			final ProtocolToPartyConn partyconn, final Action action,
+			long now) {
+		System.out.println("received " + action);
+		state = state.with(partyconn.getParty(), action, now);
+		checkEndPhase(System.currentTimeMillis());
+	}
+
+	/**
+	 * The current phase may be completed. We check, because it may already been
+	 * handled. Proceed to next phase as needed. Reset the deadline timers and
+	 * inform parties. Increase progress if necessary. Must only be called
+	 * through {@link #endPhase} to ensure this is called only once.
+	 * 
+	 */
+	private synchronized void checkEndPhase(long now) {
+		if (!state.getPhase().isFinal(now))
+			return;
+		// phase indeed ended. Check what's up.
+		if (timer != null) {
+			timer.cancel();
+			timer = null;
+		}
+		state = state.finishPhase();
+		if (state.isFinal(now)) {
+			endNegotiation();
+			return;
+		}
+
+		state = state.nextPhase(now);
+		startPhase(now);
+	}
+
+	/**
+	 * Alternative to {@link ProtocolToPartyConnections#broadcast(Inform)},
+	 * sending only to currently negotiating parties
+	 * 
+	 * @param info the info to broadcast
+	 */
+	private void broadcastNegotiators(Inform info) {
+		System.out.println("broadcasting " + info);
+		for (PartyId party : state.getPhase().getPartyStates()
+				.getNegotiatingParties()) {
+			try {
+				state.getConnections().get(party).send(info);
+			} catch (IOException e) {
+				handleError("Party seems to have disconnected", party, e);
+			}
+		}
+	}
+
+	/**
+	 * Update state to include the given error and closes the party.
+	 * 
+	 * @param message The message to attach to the error
+	 * @param party   the party where the error occured
+	 * @param e       the exception that occured.
+	 */
+	private void handleError(final String message, final PartyId partyid,
+			final Throwable e) {
+		if (e instanceof ProtocolException) {
+			state = state.with((ProtocolException) e);
+		} else {
+			state = state.with(new ProtocolException(message, partyid, e));
+		}
+		log.log(Level.WARNING,
+				"MOPAC intercepted error from party " + partyid + ":" + message,
+				e);
+	}
+
+//	/**
+//	 * Sets the new state. If the new state is final, the finish-up procedure is
+//	 * executed. All state changes go through here to ensure we check isFinal
+//	 * before any state change.
+//	 * 
+//	 * @param newstate the new state.
+//	 */
+//	private synchronized void setState(MOPACState newstate) {
+//		long now = System.currentTimeMillis();
+//		if (state.isFinal(now)) {
+//			endNegotiation();
+//			return;
+//		}
+//
+//		this.state = newstate;
+//		if (newstate.isFinal(now)) {
+//			endNegotiation();
+//		}
+//	}
+
+	/**
+	 * To be called when we reach final state. Must only be called if
+	 * {@link MOPACState#isFinal(long)}. Send finished info to all parties.
+	 * Double calls are automatically ignored using the global finished flag.
+	 */
+	private synchronized void endNegotiation() {
+		if (finished)
+			return;
+		finished = true;
+		Finished info = new Finished(state.getAgreements());
+		for (ProtocolToPartyConn conn : state.getConnections()) {
+			try {
+				conn.send(info);
+				conn.close();
+			} catch (Exception e) {
+				log.log(Level.INFO, "Failed to send Finished to " + conn, e);
+			}
+		}
+		notifyListeners(new CurrentNegoState(state));
+	}
+
+}
